﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using ZXing;
using System.Drawing.Printing;

namespace TestQRCode
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            pictureBox1.ContextMenuStrip = contextMenuStrip1;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            pictureBox1.Image = Generate(textBox1.Text);
        }

        private Bitmap Generate(string value, int width = 200, int height = 200)
        {
            return new ZXing.Rendering.BitmapRenderer().Render(new ZXing.QrCode.QRCodeWriter().encode(value, BarcodeFormat.QR_CODE, width, height), BarcodeFormat.QR_CODE, value);
        }

        private void saveAsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (pictureBox1.Image != null)
            {
                SaveFileDialog sfd = new SaveFileDialog();
                sfd.InitialDirectory = Convert.ToString(Environment.SpecialFolder.MyDocuments);
                sfd.Filter = "PNG Files (*.png)|*.png|JPG Files (*.jpg)|*.jpg|BMP Files (*.bmp)|*.bmp";
                sfd.FilterIndex = 1;

                if (sfd.ShowDialog() == DialogResult.OK)
                    pictureBox1.Image.Save(sfd.FileName);
            }
        }

        private void printToolStripMenuItem_Click(object sender, EventArgs e)
        {
            PrintDocument pd = new PrintDocument();
            pd.PrintPage += PrintPage;

            PrintDialog ppd = new PrintDialog();
            ppd.Document = pd;
            DialogResult result = ppd.ShowDialog();

            if (result == DialogResult.OK)
                pd.Print();
        }
        private void PrintPage(object o, PrintPageEventArgs e)
        {
            e.Graphics.DrawImage(pictureBox1.Image, new Point(0, 0));
        }

        private void printWithTextToolStripMenuItem_Click(object sender, EventArgs e)
        {
            PrintDocument pd = new PrintDocument();
            pd.PrintPage += PrintPageText;

            PrintDialog ppd = new PrintDialog();
            ppd.Document = pd;
            DialogResult result = ppd.ShowDialog();

            if (result == DialogResult.OK)
                pd.Print();
        }
        private void PrintPageText(object o, PrintPageEventArgs e)
        {
            int Left = 0;
            e.Graphics.DrawImage(pictureBox1.Image, new Point(0 + Left, 0));
            e.Graphics.DrawString(textBox1.Text, textBox1.Font, new SolidBrush(Color.Black), new Point(25 + Left, pictureBox1.Height));
        }

    }
}
